/*  UI-related functions */


void mousePressed()
{
  //keyboard button -- toggle virtual keyboard
  if (mouseY <= 50 && mouseX > 0 && mouseX < width/3)
    KetaiKeyboard.toggle(this);
  else if (mouseY <= 50 && mouseX > width/3 && mouseX < 2*(width/3)) //config button
  {
    isConfiguring=true;
  }
  else if (mouseY <= 50 && mouseX >  2*(width/3) && mouseX < width) // draw button
  {
    if (isConfiguring)
    {
      //if we're entering draw mode then clear canvas
      background(78, 93, 75);
      isConfiguring=false;
    }
  }
  //if(300 <= mouseX && mouseX <= 400 && 500 <= mouseY && mouseY <= 600)
  //{
  //  message[0] = 70;
  //  bt.broadcast(message);
  //  fill(255,255,0);
  //  rect(300, 500, 100, 100);
  //}
  //else
  //{
  //  fill(0,0,0);
  //  rect(300, 500, 100, 100);
  //}
  
}

void mouseDragged()
{
  if (isConfiguring)
    return;

  //send data to everyone
  //  we could send to a specific device through
  //   the writeToDevice(String _devName, byte[] data)
  //  method.
  OscMessage m = new OscMessage("/remoteMouse/");
  m.add(mouseX);
  m.add(mouseY);

  bt.broadcast(m.getBytes());
  ellipse(mouseX, mouseY, 20, 20);
}

public void keyPressed() {
  OscMessage msg = new OscMessage("/RobotChenilles/");
  
  message[0]= 0;
  msg.add('0');
  if (key =='c')
  {
    //If we have not discovered any devices, try prior paired devices
    if (bt.getDiscoveredDeviceNames().size() > 0)
      klist = new KetaiList(this, bt.getDiscoveredDeviceNames());
    else if (bt.getPairedDeviceNames().size() > 0)
      klist = new KetaiList(this, bt.getPairedDeviceNames());
  }
  else if (key == 'd')
  {
    bt.discoverDevices();
  }
  else if (key == 'x')
    bt.stop();
  else if (key == 'b')
  {
    bt.makeDiscoverable();
  }
  else if (key == 's')
  {
    bt.start();
  }
  else if (key == '0')
  {
    msg.set(0,'0');
    message[0] = 48;
    bt.broadcast(message); 
    // bt.writeToDevice("/RobotChenilles/",msg.getBytes());
  }
  else if (key == '1')
  {
    msg.set(0,'1');
    message[0] = 49;
    bt.broadcast(message); 
    // bt.writeToDevice("/RobotChenilles/",msg.getBytes());
  }
  else if (key == '2')
  {
    msg.set(0,'2');
    message[0] = 50;
    bt.broadcast(message); 
    // bt.writeToDevice("/RobotChenilles/",msg.getBytes());
  }  
  else if (key == '3')
  {
    msg.set(0,'3');
    message[0] = 50;
    bt.broadcast(message);  
    // bt.writeToDevice("/RobotChenilles/",msg.getBytes());
  }
  else if (key == 'F')
  {
    msg.set(0,'F');
    message[0] = 70;
    bt.broadcast(message); 
    // bt.writeToDevice("/RobotChenilles/",msg.getBytes());
  }   
  else if (key == 'B')
  {
    msg.set(0,'B');
    message[0] = 66;
    bt.broadcast(message); 
    // bt.writeToDevice("/RobotChenilles/",msg.getBytes());
  }  
  else if (key == 'R')
  {
    msg.set(0,'R');
    message[0] = 82;
    bt.broadcast(message); 
    // bt.writeToDevice("/RobotChenilles/",msg.getBytes());
  }   
  else if (key == 'L')
  {
    msg.set(0,'L');
    message[0] = 76;
    bt.broadcast(message); 
    // bt.writeToDevice("/RobotChenilles/",msg.getBytes());
  }   
  else if (key == 't')
  {
    msg.set(0,'t');
    message[0] = 116;
    bt.broadcast(message); 
    // bt.writeToDevice("/RobotChenilles/",msg.getBytes());
  }   
  else if (key == 'e')
  {
    msg.set(0,'e');
    message[0] = 101;
    bt.broadcast(message); 
    // bt.writeToDevice("/RobotChenilles/",msg.getBytes());
  }   
  else if (key == 'S')
  {
    msg.set(0,'S');
    message[0] = 83;
    bt.broadcast(message);  
    // bt.writeToDevice("/RobotChenilles/",msg.getBytes());
  }     
}


void drawUI()
{
  //Draw top shelf UI buttons

  pushStyle();
  fill(0);
  stroke(255);
  rect(0, 0, width/3, 50);

  if (isConfiguring)
  {
    noStroke();
    fill(78, 93, 75);
  }
  else
    fill(0);

  rect(width/3, 0, width/3, 50);

  if (!isConfiguring)
  {  
    noStroke();
    fill(78, 93, 75);
  }
  else
  {
    fill(0);
    stroke(255);
  }
  rect((width/3)*2, 0, width/3, 50);

  fill(255);
  text("Keyboard", 5, 30); 
  text("Bluetooth", width/3+5, 30); 
  text("Interact", width/3*2+5, 30); 

  popStyle();
}

void onKetaiListSelection(KetaiList klist)
{
  String selection = klist.getSelection();
  bt.connectToDeviceByName(selection);

  //dispose of list for now
  klist = null;
}
